﻿using System;
using System.Runtime.InteropServices;
using System.Windows;
using System.Windows.Interop;

namespace TestProject;

/// <summary>
/// 윈도우 헬퍼
/// </summary>
public static class WindowHelper
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Import
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 활성 윈도우 설정하기 - SetForegroundWindow(windowHandle)

    /// <summary>
    /// 활성 윈도우 설정하기
    /// </summary>
    /// <param name="windowHandle">윈도우 핸들</param>
    /// <returns>처리 결과</returns>
    [DllImport("user32")]
    private static extern bool SetForegroundWindow(IntPtr windowHandle);

    #endregion
    #region 윈도우 표시하기 - ShowWindow(windowHandle, command)

    /// <summary>
    /// 윈도우 표시하기
    /// </summary>
    /// <param name="windowHandle">윈도우 핸들</param>
    /// <param name="command">명령</param>
    /// <returns>처리 결과</returns>
    [DllImport("user32")]
    private static extern bool ShowWindow(IntPtr windowHandle, int command);

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    /// SW_SHOW
    /// </summary>
    private const int SW_SHOW = 5;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region 윈도우 앞으로 가져오기 - BringToFront(window)

    /// <summary>
    /// 윈도우 앞으로 가져오기
    /// </summary>
    /// <param name="window">윈도우</param>
    public static void BringToFront(Window window)
    {
        WindowInteropHelper windowInteropHelper = new WindowInteropHelper(window);

        nint windowHandle = windowInteropHelper.Handle;

        ShowWindow(windowHandle, SW_SHOW);

        SetForegroundWindow(windowHandle);
    }

    #endregion
}